diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/s_user.c ircd-hybrid-6b124/src/s_user.c
--- ircd-hybrid-6b124.orig/src/s_user.c	Sun Apr 30 09:56:28 2000
+++ ircd-hybrid-6b124/src/s_user.c	Sun Apr 30 09:47:32 2000
@@ -480,6 +480,7 @@
 {
   char* ch   = nick;
   char* endp = ch + NICKLEN;
+  int got_alnum = 0;
   assert(0 != nick);
 
   if (*nick == '-' || IsDigit(*nick)) /* first character in [0..9-] */
@@ -488,9 +489,10 @@
   for ( ; ch < endp && *ch; ++ch) {
     if (!IsNickChar(*ch))
       break;
+    if (isalnum(*ch)) got_alnum++;
   }
   *ch = '\0';
-
+  if (got_alnum < 2 && (ch - nick) > 3) return 0;
   return (ch - nick);
 }
 
@@ -1003,6 +1005,7 @@
 int valid_username(const char* username)
 {
   const char *p = username;
+  int uppercases = 0;
   assert(0 != p);
 
   if ('~' == *p)
@@ -1020,7 +1023,9 @@
   while (*++p) {
     if (!IsUserChar(*p))
       return NO;
+    if (isupper(*p)) uppercases++;
   }
+  if (uppercases > 2) return NO;
   return YES;
 }
 
@@ -1246,6 +1251,9 @@
                          me.name,
                          sptr->name,
                          MAX_NICK_TIME);
+              sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s (nick)",
+                                      sptr->name, sptr->username, sptr->host, me.name);
+
               return 0;
             }
 #endif
@@ -1258,6 +1266,10 @@
               add_history(sptr,1);
               sendto_serv_butone(cptr, ":%s NICK %s :%lu",
                                  parv[0], nick, sptr->tsinfo);
+              sendto_realops_flags(FLAGS_NCHANGE,
+                                 "Nick change: From %s to %s [%s@%s]",
+                                 parv[0], nick, sptr->username,
+                                 sptr->host);
             }
         }
     }
@@ -1418,6 +1430,10 @@
               return exit_client(cptr,sptr,&me,"BadNick");
             }
         }
+      else
+        sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Illegal nick \"%s\" from: %s %s",
+                                parv[1], parv[0],
+                                get_client_name(cptr, FALSE));
       return 0;
     }
 
